<template>
  <div class="home-section" :class="{ mobile: isMobile() }">
    <div class="main">
      <div v-for="(data, indData) in dataHome" :key="indData">
        <div class="wrap-subtitle">
          <h3 class="sub-title">{{ data.title }}</h3>
          <div class="right">
            <span
              class="prev"
              :class="data.arrow.prev ? data.arrow.prev : 'hide'"
              @click="triggerClick('prev', indData)"
              v-if="!isMobile()"
              ><a-icon type="left" />
            </span>
            <span
              class="next"
              :class="data.arrow.next ? data.arrow.next : 'hide'"
              @click="triggerClick('next', indData)"
              v-if="!isMobile()"
              ><a-icon type="right" />
            </span>
          </div>
        </div>
        <carousel
          :margin="10"
          :dots="false"
          :nav="false"
          :responsive="{ 0: { items: 3 }, 576: { items: 3 }, 768: { items: 4 }, 992: { items: 5 }, 1500: { items: 6 } }"
          @changed="syncArrow('next', 'prev', data.arrow, indData)"
        >
          <template slot="prev"><span :class="indData + `-prev`" ref="next">prev</span></template>
          <template slot="next"><span :class="indData + `-next`" ref="prev">next</span></template>
          <div class="product-item category" v-for="(item, ind) in data.listData" :key="ind" @click="goDetail(data, item, data.listData)">
            <div class="wrap-image square">
              <img :src="item.img_thumb || item.img_banner" />
              <div class="background-slot wrap-btn-gl">
                <span class="btn-play-gl" @click.stop="playMusic(item, data.listData)">
                  <a-icon type="caret-right" />
                </span>
              </div>
            </div>
            <h5 class="title">{{ item.name }}</h5>
            <p class="des" v-if="!isMobile() && (item.content || item.description)">
              {{ item.content || item.description }}
            </p>
          </div>
        </carousel>
        <br v-if="!isMobile()" /><br v-if="!isMobile()" />
      </div>
      <artist-list></artist-list>
    </div>
  </div>
</template>

<script>
import carousel from "vue-owl-carousel";
import service from "../service.js";
import ArtistList from "./artists/Index";

export default {
  components: { carousel, ArtistList },
  data() {
    return {
      categoryArrow: {
        prev: true,
        next: true
      },
      productArrow: {
        prev: true,
        next: true
      },
      dataHome: {},
      listArtist: {}
    };
  },
  watch: {
    "$store.state.app.initialData": {
      immediate: true,
      handler(newValue, oldValue) {
        if (JSON.stringify(newValue) === JSON.stringify(oldValue)) return;
        this.dataHome = newValue;
      }
    },
    "$store.state.app.listArtist": {
      immediate: true,
      handler(val, oldVal) {
        if (JSON.stringify(val) === JSON.stringify(oldVal)) return;
        this.listArtist = val;
      }
    }
  },
  methods: {
    isMobile() {
      if (/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)) {
        return true;
      } else {
        return false;
      }
    },
    syncArrow(prev, next, arrowObject, k) {
      const me = this;
      setTimeout(function() {
        const prevParent = me.$refs[prev] && me.$refs[prev].parentNode;
        const nextParent = me.$refs[next] && me.$refs[next].parentNode;
        if (prevParent) {
          arrowObject.prev = prevParent.style.display !== "none";
        }
        if (nextParent) {
          arrowObject.next = nextParent.style.display !== "none";
        }
      }, 200);
    },
    triggerClick(ref, k) {
      console.log(this.$refs);
      try {
        if (this.$refs[ref][k]) {
          this.$refs[ref][k].click();
        }
      } catch (e) {
        console.log(e);
      }
    },
    itemOver(item) {
      item.over = true;
    },
    itemLeave(item) {
      item.over = false;
    },
    playMusic(item, playlist) {
      if (!item.song_file) return;

      this.$store.dispatch("player/playMusic", {
        id: item.id,
        url: item.song_file,
        title: item.name,
        artist: item.artist_name,
        photo: item.img_thumb || item.img_banner
      });

      // Set current playlist
      playlist = playlist.map(item => {
        return ({
          id: item.id,
          url: item.song_file,
          title: item.name,
          artist: item.artist_name,
          photo: item.img_thumb || item.img_banner
        });
      })
      this.$store.commit('player/setPlaylist', playlist);
    },
    goDetail(data, item, playlist) {
      if (data.type === 'music') {
        this.playMusic(item, playlist);
        return;
      }
      this.$router.push(`/detail/${item.id}`);
    },
    all() {
      this.$router.push("/mood");
    }
  },
  mounted() {
    this.dataHome.forEach((v, k) => {
      this.syncArrow("next", "prev", v.arrow, k);
    });
  }
};
</script>

<style scoped>
@import "../css/default.css";

.icon-slider {
  font-size: 16px;
  margin: 0 5px;
}

.mobile .sub-title {
  font-weight: 500;
  font-size: 18px;
  line-height: 27px;
  text-align: center;
  letter-spacing: -0.24px;
  color: #f1f1f1;
  padding-left: 6px;
}

.background-slot {
  background-color: #1514146e;
  width: 100%;
  height: 100%;
  position: absolute;
  top: 0;
  visibility: hidden;
}

.product-item:hover .background-slot {
  visibility: visible;
  transition: 0.3s;
}

.slide-item {
  position: relative;
}

.slide-item .title {
  position: absolute;
  width: 100%;
  bottom: 0;
  font-size: 14px;
  padding: 10px;
  font-weight: 400;
}

.product-item {
  cursor: pointer;
}
.home-section:not(.mobile) .product-item {
  height: 312px;
}

.product-item:hover img {
  opacity: 0.7;
}

.product-item .title {
  font-size: 14px;
  text-transform: capitalize;
  padding: 5px 0;
  font-weight: 500;
  letter-spacing: -0.015em;
}
.mobile .product-item .title {
  font-weight: 400;
}

.product-item .title:hover {
  text-decoration: underline;
}

.product-item .des {
  font-weight: 300;
  font-size: 14px;
  line-height: 21px;
  color: #f1f1f1;
  display: -webkit-box;
  -webkit-line-clamp: 2;
  -webkit-box-orient: vertical;
  overflow: hidden;
  opacity: 0.7;
}

/* Mobile Style */
.mobile .product-item {
  padding: 0;
  height: 166px;
}
.mobile .product-item .wrap-image {
  margin-bottom: 8px;
}
.mobile .product-item .title {
  text-align: center;
  font-size: 13px;
  font-weight: 600;
  display: -webkit-box;
  -webkit-line-clamp: 2;
  -webkit-box-orient: vertical;
  overflow: hidden;
}

[class*="-prev"],
[class*="-next"] {
  position: absolute;
  z-index: -1;
}
</style>
